function [f,g,x] = oilwell_cost(x)
 [L,O] = oil_data();
 
if nargin == 0
	prob.nx = 56;
	prob.nf = 1;
	prob.ng = 1;
	prob.range = cell(1, prob.nx);
    
	for i = 1:prob.nx
		prob.range{i} = Range('range', [min(L{i}), max(L{i})]);
	end
	f = prob;
else
	[f,g,x] = oilwell_true(double(x),L,O);
end
return


function [f,g,x] = oilwell_true(x,L,O)

temp_x = x;
temp_x(temp_x < 0) = 0;

ff = [];
for i = 1:length(x)
    ff(i) = interp1(L{i},O{i},temp_x(i),'linear');
end

idx = find(temp_x <= 5); % Remove the wells injected with less than 5 MSCF
ff(idx) = 0;

temp_x(idx) = 0;

used = 56-length(idx);

f(1) = -(75*sum(ff) - 1.5*sum(temp_x) - used*6700);

g(1) = 22500 - sum(temp_x);

x = temp_x;

return

